﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="DdlProvider_LoadOnDemand.aspx.vb" Inherits="Ddl_LoadOnDemand.DdlProvider_LoadOnDemand" %>

<%@ Register TagPrefix="ig" Namespace="Infragistics.Web.UI.GridControls" Assembly="Infragistics45.Web.v14.1, Version=14.1.20141.2150, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <link href="~/Styles/Styles.css" rel="stylesheet" type="text/css" />
</head>
<script type="text/javascript">
    var cellActive;
    var cellText;
    var _DDL_LAST_NAME_DropDownProvider;

    function DDL_LAST_NAME_DropDownProvider_Initialize(sender, eventArgs) {
        _DDL_LAST_NAME_DropDownProvider = sender;
    }

    function DropDownProvider_Opening(sender, eventArgs) {
        sender._elements.DropDownContents.style.cssText = "overflow:auto; width:" + sender._element.clientWidth + "px; height:160px;";    // height:160px;
    }

    function StringForNull(val) {
        if (val == null) {
            return "";
        } else {
            return val;
        }
    }

    function WDG_ThirdParty_EditingCore_CellValueChanged(sender, eventArgs) {
        var cell = eventArgs.get_cell();
        if (cell.get_column().get_key() != "Static") {
            if (cell.get_column().get_key() == "Ledger_Type_Lkup_ID") {
                cell.get_row().get_cellByColumnKey("Entity_ID").set_value('');
            }
        }
    }

    function WDG_ThirdParty_CellEditing_ExitedEditMode(sender, eventArgs) {
        var cell = eventArgs._cell;
        var row = cell.get_row();
        var column = cell.get_column();
        var key = column.get_key();

        if (key == "Entity_ID") {
            cell.set_text(StringForNull(cellText));
        }
    }

    function WDG_ThirdParty_CellEditing_EnteringEditMode(sender, eventArgs) {
        var cell = eventArgs._cell;
        var row = cell.get_row()
        cellActive = cell;

        if (cell.get_column().get_key() == "Entity_ID") {
            var Ledger_Type_Lkup_ID = StringForNull(row.get_cellByColumnKey("Ledger_Type_Lkup_ID").get_value());
            if (_DDL_LAST_NAME_DropDownProvider != null) {
                _DDL_LAST_NAME_DropDownProvider.loadItems("INIT" + '$$#$$' + Ledger_Type_Lkup_ID + '$$#$$');
            }
        }
    }

    function DDL_LAST_NAME_Provider_InputKeyUp(sender, eventArgs) {
        document.getElementById("HD_SearchName").value = StringForNull(sender._elements.Input["value"]);
        if (cellActive != null) {
            var row = cellActive.get_row();
            var grid = row.get_grid();
            document.getElementById("HD_LedgerType").value = StringForNull(row.get_cellByColumnKey("Ledger_Type_Lkup_ID").get_value());
        }
    }

    function DDL_LAST_NAME_DropDownProvider_DropDownClosing(sender, eventArgs) {
        if (sender.get_selectedItem() == null) {
            //if (sender._elements["List"].childNodes.length == 2) {
            //    cellText = sender._elements["List"].childNodes[1].textContent;
            //    //sender.set_currentValue(cellText, true);
            //    //sender.set_activeItem(sender._elements["List"].childNodes[1], false);
            //    sender.set_selectedItemIndex(1);
            //    return;
            //}
            if (sender.get_items().get_length() == 2) {
                cellText = sender.get_items().get_item(sender.get_items().get_length() - 1).get_text();
                //sender.set_currentValue(cellText, true);
                //sender.set_activeItem(sender.get_items().get_item(sender.get_items().get_length() - 1), false);
                sender.set_selectedItemIndex(1);
                return;
            }
            if (cellActive != null) {
                cellText = cellActive.get_text();
                sender.set_currentValue(cellText, false);
                return;
            }
        }
    }
</script>
<body style="margin: 6px;">
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server" />
        <asp:UpdatePanel ID="UpdatePanel1" runat="server" ChildrenAsTriggers="True" UpdateMode="Always" RenderMode="Inline">
            <ContentTemplate>
                <table class="NormalText" style="padding: 0; width: 100%; border: 0px solid silver; border-top-width: 0; border-collapse: collapse;">
                    <tr>
                        <td style="padding: 0;">
                            <table class="NormalText" style="padding: 0; border: 1px solid silver; border-top-width: 0; border-collapse: collapse;" id="TBL_Main">
                                <tr>
                                    <td class="DataGridTitleBar" style="height: 18px">Third Party Vendor</td>
                                </tr>
                                <tr>
                                    <td style="padding: 0; vertical-align: top;">
                                        <ig:WebDataGrid ID="WDG_ThirdParty" runat="server" AutoGenerateColumns="False" DataKeyFields="ID" Font-Bold="False"
                                            EnableAjax="False" EnableDataViewState="True" EnableViewState="True" Height="150px" Width="100%">
                                            <Columns>
                                                <ig:BoundDataField DataFieldName="ID" Key="ID" Hidden="True"></ig:BoundDataField>
                                                <ig:BoundDataField DataFieldName="Ledger_Type_Lkup_ID" Width="130px" Key="Ledger_Type_Lkup_ID" CssClass="NormalTextLeft">
                                                    <Header Text="Type" />
                                                </ig:BoundDataField>
                                                <ig:BoundDataField DataFieldName="Entity_ID" Key="Entity_ID" Width="200px" CssClass="NormalTextLeft">
                                                    <Header Text="Company Name" CssClass="NormalTextCenter" />
                                                </ig:BoundDataField>
                                                <ig:BoundDataField DataFieldName="LAST_NAME" Width="200px" Key="LAST_NAME" Hidden="False" CssClass="NormalTextLeft">
                                                    <Header Text="Entity Name" CssClass="NormalTextCenter" />
                                                </ig:BoundDataField>
                                            </Columns>
                                            <EditorProviders>
                                                <ig:DropDownProvider ID="DDL_Ledger_Type_Lkup_ID_DropDownProvider" StretchHeight="False">
                                                    <EditorControl ClientIDMode="Predictable" DropDownContainerMaxHeight="100px" NullText=""
                                                        EnableClientRendering="False" TextField="DESCRIPTION" ValueField="ID"
                                                        EnableViewState="True" DisplayMode="DropDownList">
                                                        <ClientEvents DropDownOpening="DropDownProvider_Opening" />
                                                    </EditorControl>
                                                </ig:DropDownProvider>
                                                <ig:DropDownProvider ID="DDL_LAST_NAME_DropDownProvider" StretchHeight="False">
                                                    <EditorControl ClientIDMode="Predictable" DropDownContainerMaxHeight="160px"
                                                        EnableClientRendering="false" TextField="LAST_NAME" NullText=""
                                                        EnableViewState="True" DisplayMode="DropDown" EditorID="DDL_LAST_NAME_Editor"
                                                        EnableAutoFiltering="Server" EnableLoadOnDemand="True"
                                                        AutoFilterResultSize="10" PageSize="10" DataKeyFields="ID"
                                                        OnItemsRequested="DDL_LAST_NAME_DropDownProvider_ItemsRequested"
                                                        OnLoad="DDL_LAST_NAME_DropDownProvider_LoadOnDemand"
                                                        EnableAutoCompleteFirstMatch="False"
                                                        EnableDropDownAsChild="True" DropDownContainerWidth="200px">
                                                        <ClientEvents DropDownOpening="DropDownProvider_Opening"
                                                            InputKeyUp="DDL_LAST_NAME_Provider_InputKeyUp"
                                                            Initialize="DDL_LAST_NAME_DropDownProvider_Initialize"
                                                            DropDownClosing="DDL_LAST_NAME_DropDownProvider_DropDownClosing"
                                                            SelectionChanged="" />
                                                    </EditorControl>
                                                </ig:DropDownProvider>
                                            </EditorProviders>
                                            <Behaviors>
                                                <ig:EditingCore BatchUpdating="True">
                                                    <EditingClientEvents CellValueChanged="WDG_ThirdParty_EditingCore_CellValueChanged" />
                                                    <Behaviors>
                                                        <ig:CellEditing Enabled="true" EditCellCssClass="NormalText">
                                                            <ColumnSettings>
                                                                <ig:EditingColumnSetting ColumnKey="Ledger_Type_Lkup_ID" EditorID="DDL_Ledger_Type_Lkup_ID_DropDownProvider" />
                                                                <ig:EditingColumnSetting ColumnKey="Entity_ID" EditorID="DDL_LAST_NAME_DropDownProvider" />
                                                            </ColumnSettings>
                                                            <CellEditingClientEvents EnteringEditMode="WDG_ThirdParty_CellEditing_EnteringEditMode"
                                                                ExitedEditMode="WDG_ThirdParty_CellEditing_ExitedEditMode" />
                                                            <EditModeActions MouseClick="Single" EnableOnActive="True" />
                                                        </ig:CellEditing>
                                                    </Behaviors>
                                                </ig:EditingCore>
                                                <ig:Activation Enabled="true">
                                                </ig:Activation>
                                                <ig:Selection CellClickAction="Cell" RowSelectType="Single" Enabled="true">
                                                </ig:Selection>
                                                <ig:RowSelectors Enabled="True" RowNumbering="False" EnableInheritance="True">
                                                    <RowSelectorClientEvents RowSelectorClicked=""></RowSelectorClientEvents>
                                                </ig:RowSelectors>
                                                <ig:Paging PageSize="16" Enabled="False" QuickPages="9" />
                                            </Behaviors>
                                        </ig:WebDataGrid>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="width: 100%; text-align: left;">
                                        <div id="DIV_Paging_ThirdParty" runat="server" style="width: 100%; text-align: left; padding-left: 4px"></div>
                                    </td>
                                </tr>
                                <tr>
                                    <td style="display: none;">
                                        <input id="HD_LedgerType" runat="server" type="hidden" value="" />
                                        <input id="HD_SearchName" runat="server" type="hidden" value="" />
                                    </td>
                                </tr>
                                <tr>
                                    <td style="padding: 4px;">
                                        <asp:Button ID="BT_Add_Third" runat="server" CssClass="ButtonText" Width="55px"
                                            Text="Add" UseSubmitBehavior="False" />
                                        <asp:Button ID="BT_Delete_Third" runat="server" CssClass="ButtonText" Width="55px"
                                            Text="Delete" />
                                        <input class="ButtonText" id="BT_GoTo" style="width: 75px"
                                            type="button" value="Go to Entity" runat="server" />
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td style="padding-left: 10px;">
                            <asp:Label Text="" ID="LBL_Msg" CssClass="NormalText" runat="server" />
                        </td>
                    </tr>
                    <tr>
                        <td style="text-align: center; padding-top: 15px; padding-bottom: 20px;">
                            <asp:Button Text="Submit" CssClass="ButtonText" ID="BT_Submit" Width="65px" runat="server" />
                        </td>
                    </tr>
                </table>
            </ContentTemplate>
        </asp:UpdatePanel>
    </form>
</body>
</html>
