﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="WebDDL_LoadOnDemand.aspx.vb" Inherits="Ddl_LoadOnDemand.WebDDL_LoadOnDemand" %>

<%@ Register Assembly="Infragistics45.Web.v14.1, Version=14.1.20141.2150, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.ListControls" TagPrefix="ig" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <link href="~/Styles/Styles.css" rel="stylesheet" type="text/css" />
</head>
<script type="text/javascript">
    function wcType_InputKeyUp(sender, eventArgs) {
        document.getElementById("HD_SearchType").value = sender._elements.Input["value"];
    }

    var iOpen = 0;
    var flagInit = false;
    function wcType_DropDownOpening(sender, eventArgs) {
        if (document.getElementById("HD_SearchType").value == "") {
            if (flagInit) {
                flagInit = false;
                sender.loadItems("", true);     //# load all data
            }
        }
        var activeItem;
        if (sender.get_selectedItems().length > 0) {
            for (var i = 0; i < sender.get_selectedItems().length; i++) {
                var item = sender.get_items().getItem(sender.get_selectedItems()[i].get_index());
                if (item != null) {
                    if (document.getElementById("HD_Entity_ID").value > 0) {
                        if (parseFloat(item.get_value()) == parseFloat(document.getElementById("HD_Entity_ID").value)) {
                            item.select();
                            activeItem = item;
                            break;
                        }
                    }
                    item.unselect();
                    item.inactivate();
                }
            }
            if (activeItem != null) {
                sender.set_activeItem(activeItem);
            }
        }
        if (sender.get_activeItem() != null) {
            if (parseFloat(sender.get_activeItem().get_value()) == 0) {
                iOpen = 1;
            } else {
                iOpen += 2;
            }
        }
    }

    function wcType_DropDownClosing(sender, eventArgs) {
        var selectedValue = 0;
        if (sender._activeItem != null) {
            if (parseFloat(sender._activeItem.get_value()) != 0) {
                selectedValue = parseFloat(sender._activeItem.get_value());
            } else {
                if (iOpen != 1) {
                    flagInit = true;
                    document.getElementById("HD_Entity_ID").value = "";
                    document.getElementById("HD_Entity_Name").value = "";
                    document.getElementById("HD_SearchType").value = "";
                    return;
                }
            }
        }
        if (selectedValue != 0) {
            flagInit = true;
            document.getElementById("HD_Entity_ID").value = selectedValue;
            document.getElementById("HD_Entity_Name").value = sender._activeItem.get_text();
            document.getElementById("HD_SearchType").value = "";
        } else {
            //# when the search results are 2 items (including blank item), the item second to be selected
            if (sender._elements["List"].childNodes.length == 2) {
                var item = sender._elements["List"].childNodes[1];
                if (item != null) {
                    flagInit = true;
                    var olistItems = sender.get_items().get_length();               //#but can't get real list items ?
                    //alert(olistItems);                                            //or not ALWAYS right  
                    //document.getElementById("HD_Entity_ID").value = ????????;     //#can't get value
                    //if (sender.get_items().get_length() == 2) {
                    //    var itemSelected = sender.get_items().get_item(sender.get_items().get_length() - 1);
                    //    if (itemSelected != null) {
                    //        document.getElementById("HD_Entity_ID").value = item.get_value();
                    //        document.getElementById("HD_Entity_Name").value = item.get_text();
                    //        document.getElementById("HD_SearchType").value = "";
                    //        sender.set_currentValue(item.get_text(), true);
                    //        return;
                    //    }
                    //}
                    document.getElementById("HD_Entity_Name").value = item.textContent;
                    document.getElementById("HD_SearchType").value = "";
                    sender.set_currentValue(item.textContent, true);
                    return;
                }
            }
            //# if search results has more 2 items and no one item selected, return old value
            if (sender._elements["List"].childNodes.length > 0) {
                flagInit = true;
                document.getElementById("HD_SearchType").value = "";
                sender.set_currentValue(document.getElementById("HD_Entity_Name").value, true);
                return;
            }
        }
    }
</script>
<body style="margin:6px;">
    <form id="form1" runat="server">
        <asp:ScriptManager runat="server" EnablePartialRendering="true" />
        <asp:UpdatePanel runat="server">
            <ContentTemplate>
                <table style="border:0; padding:0; border-collapse:collapse; width:100%;" class="NormalText">
                    <tr>
                        <td style="padding-left:200px;">
                            <ig:WebDropDown ID="wcType" runat="server" Width="240px" DropDownContainerMaxHeight="150px"
                                NullText="&nbsp;" EnableAutoFiltering="Server" EnableLoadOnDemand="True" AutoFilterQueryType="Contains"
                                EnableAutoCompleteFirstMatch="false" PageSize="9" EnableViewState="True" DataKeyFields="ID"
                                TextField="LAST_NAME" ValueField="ID" AutoFilterResultSize="16"
                                CssClass="NormalText" EnableDropDownAsChild="true">
                                <ClientEvents InputKeyUp="wcType_InputKeyUp"
                                    DropDownClosing="wcType_DropDownClosing"
                                    DropDownOpening="wcType_DropDownOpening">
                                </ClientEvents>
                            </ig:WebDropDown>
                        </td>
                    </tr>
                    <tr>
                        <td style="display:none;">
                            <input type="hidden" id="HD_SearchType" runat="server" value="" />
                            <input type="hidden" runat="server" id="HD_Entity_ID" value="" />
                            <input type="hidden" runat="server" id="HD_Entity_Name" value="" />
                        </td>
                    </tr>
                </table>
            </ContentTemplate>
        </asp:UpdatePanel>
    </form>
</body>
</html>
